<template>
  <v-row>
    <v-row cols="12">
      <v-col cols="6">
        <v-card-text class="text-h1">Table</v-card-text>
      </v-col>
      <v-col cols="6" class="text-right pr-7">
        <v-btn icon="mdi-plus" size="large" color="#5865f2" class="mb-4" align-self="center" @click="goToOtherPage"></v-btn>
      </v-col>
    </v-row>
    <v-col cols="12">
      <!-- ตารางแสดงข้อมูล -->
      <v-table theme="dark">
        <thead>
          <tr>
            <!-- ลูปแสดงชื่อของแต่ละ column -->
            <th class="text-center" v-for="item in columns" :key="item.name">
              {{ item.name }}
            </th>
          </tr>
        </thead>
        <tbody>
          <!-- แสดงข้อมูล id, frist name, last name, username, image -->
          <tr v-for="row in rows" :key="row.id">
            <td class="text-center">{{ row.id }}</td>
            <td class="text-center">{{ row.fname }}</td>
            <td class="text-center">{{ row.lname }}</td>
            <td class="text-center">{{ row.username }}</td>
            <td class="text-center">
              <v-img :src="row.avatar" :width="50" class="pt-2 text-center mx-auto"></v-img>
            </td>
            <td class="text-center">
              <v-col cols="12">
                <!-- ปุ่มกดแก้ไขข้อมูล -->
                <NuxtLink :to="`/kissada/editTable/${row.id}`" class="btn btn-seccess btn-sm mx-2">
                  <v-btn icon><v-icon style="color: #7af6f2;">mdi-pencil</v-icon></v-btn>
                </NuxtLink>
                <!-- ปุ่มลบข้อมูล -->
                <v-btn icon @click="onDelete(row.id)">
                  <v-icon style="color: #D80032;">mdi-delete</v-icon>
                </v-btn>
              </v-col>
            </td>
          </tr>
        </tbody>
      </v-table>
    </v-col>
  </v-row>
</template>

<script>
import { ref, onMounted } from "vue";
import { useRouter} from "vue-router";

export default {
  setup() {
    
    const router = useRouter();
    const columns = [
      { name: "id" },
      { name: "fname" },
      { name: "lname" },
      { name: "username" },
      { name: "avatar" },
      { name: "edit" },
    ];
    
    const rows = ref([]);
    
    const goToOtherPage = () => {
      router.push(`/kissada/createTable`);
    };
    // ดึงข้อมูล จากเส้น API มาแสดง
    const runtimeConfig = useRuntimeConfig();
    const URL = runtimeConfig.public.URL_Auth;
    console.log("URL : ",URL)
    
    const fetchData = async () => {
      try {
        const res = await fetch(`${URL}/api/users`);
        const result = await res.json();
        rows.value = result;

        // เพิ่ม console.log เพื่อตรวจสอบข้อมูลที่รับมาว่ามีอะไรบ้าง
        console.log("Fetched data:", rows.value);
      } catch (error) {
        // เพิ่ม console.log เพื่อตรวจสอบการดึงข้อมูล
        console.error("Error fetching data:", error);
      }
    };
    // การลบข้อมูล
    const onDelete = async (id) => {
      try {
        const myHeaders = new Headers();
        myHeaders.append("Content-Type", "application/json");
        
        const raw = JSON.stringify({
          id: id,
        });

        const requestOptions = {
          method: "DELETE",
          headers: myHeaders,
          body: raw,
          redirect: "follow",
        };
        
        const response = await fetch(`${URL}/api/users/delete`, requestOptions);
        const result = await response.json();

        if (result) {
          alert("Delete this id: " + id + " success"); // แจ้งเตือนการลบข้อมูล
          console.log(`Deleting data with ID: ${id}`); // consle.log ว่าลบข้อมูล id ไหนไป
          fetchData();
        } else {
          console.error("Error deleting data:", result);
        }
      } catch (error) {
        console.error("Error deleting data:", error);
      }
    };

    onMounted(() => {
      fetchData();
    });
    
    return {
      columns,
      rows,
      onDelete,
      goToOtherPage,
    };
  },
};
</script>